Lua_ExpeditionBoxItem = class("Lua_ExpeditionBoxItem", Lua_DisplayObject);
function Lua_ExpeditionBoxItem:ctor(p)
	self:superCall("ctor", p, "ExpeditionBoxItem_skin");
end

function Lua_ExpeditionBoxItem:buildShowItem()
	self:superCall("buildShowItem");
	self.boxIcon:addClickFuntion(self, self.onBoxIconClick);
end

function Lua_ExpeditionBoxItem:dispose()
	if self.uiEff then
		self.uiEff:dispose();
		self.uiEff = nil;
	end
	if self.receiveEff then
		self.receiveEff:dispose();
		self.receiveEff = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ExpeditionBoxItem:setData(data)
	self.data = data;

	self.state = DataCenter.expeditionData:getStarState(data.id);
	local str = string.sub(data.box_icon, 1, string.len(data.box_icon) - 1);
	if self.state == 2 then
		self.boxIcon:setAltas("common_altas_4", str.."p");
	else
		self.boxIcon:setAltas("common_altas_4", str.."n");
	end

	if self.state == 1 then
		if str == "ui_djc_box_001_" then
			self:showEff("ui_ty_xbx_0101_1")
		elseif str == "ui_djc_box_002_" then
			self:showEff("ui_ty_xbx_0101_2")
		else
			self:showEff("ui_ty_xbx_0101_3")
		end
	else
		self:showEff(nil)
	end

	self.starNum.text = data.star_num;
	self.starNum:resetSize();
	self.starIcon:setLocation(self.starNum.posX + self.starNum.width / 2 + 10, -22, 0);
end

function Lua_ExpeditionBoxItem:showEff(value)
	if strIsNullOrEmpty(value) then
		self.boxIcon.alpha = 1;
		if self.uiEff then
			self.uiEff:setEnable(false)
		end
	else
		if self.uiEff == nil then
			self.uiEff = UICreate.createUIEffect(self.content, nil, nil, 0, 0)
			self.uiEff.siblingIndex = 1
			self.uiEff:addLuaLoadCompleteFun(self, self.onEffLoaded);
		end
		self.uiEff:setUrl("/effects/uiEffects/"..value, value);
		self.uiEff:setEnable(false)
		self.uiEff:setEnable(true)
	end
end

function Lua_ExpeditionBoxItem:onEffLoaded()
	self.boxIcon.alpha = 0.01;
end

function Lua_ExpeditionBoxItem:showReceiveEff(bValue)
	if bValue then
		if self.receiveEff == nil then
			self.receiveEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_xbx_0101_6", "ui_ty_xbx_0101_6", 0, 0)
		else
			self.receiveEff:setEnable(false)
			self.receiveEff:setEnable(true)
		end
	else
		if self.receiveEff then
			self.receiveEff:setEnable(false)
		end
	end
end

function Lua_ExpeditionBoxItem:onBoxIconClick(go)
	if self.data == nil then
		return;
	end

	if self.state == 1 then
		Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sBoxReceive(self.data.id);
	else
		Lua_WindowUtil.openWin("Lua_ExpeditionBoxDetailsWindow", Lua_WinParam.ACTION_OPEN);
	end
end