-- 增益效果选择
Lua_ExpeditionBuffChooseWindow = class("Lua_ExpeditionBuffChooseWindow", Lua_Window);
function Lua_ExpeditionBuffChooseWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ExpeditionBuffChooseWindow";
	self.skinName = "ExpeditionBuffChooseWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ExpeditionBuffChooseWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.itemArr = Array();
	local item;
	for i = 1, 3 do
		item = Lua_ExpeditionBuffChooseItem.new(self.content);
		item:setLocation(-217 + (i - 1) * 217, 60, 0);
		self.itemArr:add(item);
	end

	self:addLuaEvent("EXPEDITION_BUFF_LIST", self, self.updateShowInfo);
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sBuffList();

	self.btnChoose:setEnable(false);
	self.btnChoose:addClickFuntion(self, self.onBtnChooseClick);
end

function Lua_ExpeditionBuffChooseWindow:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	if self.isChoose ~= true then
		DataCenter.expeditionData:checkInfoUpdate();
	end
	self:superCall("dispose");
end

function Lua_ExpeditionBuffChooseWindow:updateShowInfo(msg)
	if msg == nil or msg.effect_id_list == nil or #msg.effect_id_list <= 0 then
		return;
	end

	local dic = {};
	local id;
	local config;
	if msg.buff_list ~= nil then
		for i = 1, #msg.buff_list do
			id = msg.buff_list[i];
			config = DataCenter.expeditionUtil:getBuffInfo(id);
			dic[config.type] = config.color;
		end
	end

	local len = self.itemArr:getSize();
	local num = #msg.effect_id_list;
	local maxLen = num > len and num or len;
	local item;
	for i = 1, maxLen do
		item = self.itemArr[i];
		if i > num then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_ExpeditionBuffChooseItem.new(self.content);
				self.itemArr:add(item);
			else
				item:setEnable(true);
			end

			item:setLocation(-217 + (i - 1) * 217, 60, 0);
			item:setClick(self, self.onItemClick);
			id = msg.effect_id_list[i];
			config = DataCenter.expeditionUtil:getBuffInfo(id);
			item:setData(id, dic[config.type]);
		end
	end
end

function Lua_ExpeditionBuffChooseWindow:onItemClick(data)
	self.data = data;
	self.btnChoose:setEnable(true);
	local item;
	for i = 1, self.itemArr:getSize() do
		item = self.itemArr[i];
		item:setSelected(item.data == data);
		item:setMask(not (item.data == data));
	end
end

function Lua_ExpeditionBuffChooseWindow:onBtnChooseClick(go)
	if self.data == nil then
		return;
	end

	self.isChoose = true;
	DataCenter.expeditionData.isWait = false;
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sBuffChoose(self.data);
	self:hide();
end








































Lua_ExpeditionBuffChooseItem = class("Lua_ExpeditionBuffChooseItem", Lua_DisplayObject);
function Lua_ExpeditionBuffChooseItem:ctor(p)
	self:superCall("ctor", p, "ExpeditionBuffChooseItem_skin");
end

function Lua_ExpeditionBuffChooseItem:buildShowItem()
	self:superCall("buildShowItem");
	self:setSelected(false);
end

function Lua_ExpeditionBuffChooseItem:dispose()
	TweenUtil.getInstance():stop(self.content);
	self.owner = nil;
	self.callBack = nil;
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ExpeditionBuffChooseItem:setClick(owner, callBack)
	self.bg.clickScale = false;
	self.owner = owner;
	self.callBack = callBack;
	if owner == nil or callBack == nil then
		self.bg:removeClickFuntion(self, self.onClick);
	else
		self.bg:addClickFuntion(self, self.onClick);
	end
end

function Lua_ExpeditionBuffChooseItem:onClick(go)
	if self.owner ~= nil and self.callBack ~= nil then
		self.callBack(self.owner, self.data);
	end	
end

function Lua_ExpeditionBuffChooseItem:setData(data, color)
	self.data = data;
	local config = DataCenter.expeditionUtil:getBuffInfo(data);
	if config == nil then
		return;
	end

	self.bg:setUrl("/images/expedition/ui_bjyz_window_00"..(config.color - 2)..".png");
	if config.color == 5 then
		self.name.text = Lua_ColorDefine.getColorStr("DE6D29", config.name);
	elseif config.color == 4 then
		self.name.text = Lua_ColorDefine.getColorStr("C616B7", config.name);
	else
		self.name.text = Lua_ColorDefine.getColorStr("159EC5", config.name);
	end

	if config.buff_camp == 7 then
		self.icon:setAltas("common_altas_2", "ui_common_button_025_n");
	else
		self.icon:setAltas("common_altas_2", "ui_common_button_0"..(25 + config.buff_camp).."_n");
	end
	self.icon:resetSize();

	config = Lua_SkillConfigData.getConfigData(config.skill_id);
	self.skill_icon:setAltas(config.atlas, config.sprite);
	self.des.text = config.des;

	-- if DataCenter.expeditionUtil:getConstConfig("show_buff_tips", 1, 0) == 1 then
	-- 	colorStr = Lua_ColorDefine.getItemColor(color, false);
	-- 	local str = LanUtil.formateStr(330012, Lua_ColorDefine.getColorName(color));
	-- 	self.prompt.text = Lua_ColorDefine.getColorStr(colorStr, str);
	-- else
	-- 	self.prompt.text = "";
	-- end
end

function Lua_ExpeditionBuffChooseItem:setSelected(bSelected)
	if bSelected then
		TweenUtil.getInstance():stop(self.content);
		self:setScale(1, 1, 1);
		TweenUtil.getInstance():addTweenTargetScale(self.content, 0.1, 0, 1.05, 1.05, 1.05)
		TweenUtil.getInstance():addTweenTargetScale(self.content, 0.1, 0.1, 0.9, 0.9, 0.9)
		TweenUtil.getInstance():addTweenTargetScale(self.content, 0.1, 0.2, 1, 1, 1)
	else
		self:setScale(0.9, 0.9, 0.9);
	end
end

function Lua_ExpeditionBuffChooseItem:setMask(bShow)
	if bShow then
		if self.mask == nil then
			self.mask = UICreate.createUIAtlasImage(self.content, "expedition_atlas_2", "ui_bjyz_window_018", 0, -10, 200, 463);
			self.mask:setScale(1.09, 1.09, 1.09);
		end
		self.mask:setEnable(true);
	else
		if self.mask ~= nil then
			self.mask:setEnable(false);
		end
	end
end