-- 增益效果
Lua_ExpeditionBuffWindow = class("Lua_ExpeditionBuffWindow", Lua_Window);
function Lua_ExpeditionBuffWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ExpeditionBuffWindow";
	self.skinName = "ExpeditionBuffWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ExpeditionBuffWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.prompt:setLangValue(330011);

	self:addLuaEvent("EXPEDITION_HAVEBUFF_LIST", self, self.updateShowInfo);
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sHaveBuffList();
end

function Lua_ExpeditionBuffWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_ExpeditionBuffWindow:updateShowInfo(msg)
	if msg == nil or msg.buff_list == nil or #msg.buff_list <= 0 then
		self:showNone(true);
		if self.itemList then
			self.itemList:setEnable(false);
		end
	else
		self:showNone(false);
		table.sort(msg.buff_list, function(a, b) return a > b end);
		if self.itemList == nil then
			self.itemList = Lua_DragList.new(self.content, 643, 700, Lua_AxisDefine.Vertical);
			self.itemList:setListCell(Lua_ExpeditionBuffItem, 157, 300, 4);
			self.itemList:setCellSpacing(5, 10);
		end
		self.itemList:setEnable(true);
		self.itemList:setArrayData(msg.buff_list);
	end
end

function Lua_ExpeditionBuffWindow:showNone(bShow)
	if bShow then
		if self.noneIcon == nil then
			self.noneIcon = UICreate.createUIAtlasImage(self.content, "common_altas_3", "ui_liaotian_widget_002", 0, 0, 648, 119);
		end
		self.noneIcon:setEnable(true);

		if self.noneText == nil then
			self.noneText = UICreate.createLabel(self.content, LanUtil.getValue(330013), 0, 0, 100, 40, 46);
			self.noneText.pivot = UIUtils.Pivot.Center;
			self.noneText.fontName = Lua_MyUISettings.huakangFontName;
			self.noneText.alignmentValue = 4;
			self.noneText.horizontalOverflowValue = 1;
			self.noneText.colorStr = Lua_ColorDefine.transColorStr("9F928C");
		end
		self.noneText:setEnable(true);
	else
		if self.noneIcon ~= nil then
			self.noneIcon:setEnable(false);
		end
		if self.noneText ~= nil then
			self.noneText:setEnable(false);
		end
	end
end




















Lua_ExpeditionBuffItem = class("Lua_ExpeditionBuffItem", Lua_ListCell);
function Lua_ExpeditionBuffItem:ctor(p)
	self:superCall("ctor", p, "ExpeditionBuffItem_skin");
end

function Lua_ExpeditionBuffItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ExpeditionBuffItem:dispose()
	self:superCall("dispose");
end

function Lua_ExpeditionBuffItem:setData(data)
	local config = DataCenter.expeditionUtil:getBuffInfo(data);
	if config == nil then
		return;
	end

	self.bg:setAltas("expedition_atlas_2", "ui_bjyz_window_01"..config.color + 2);
	if config.color == 5 then
		self.name.text = Lua_ColorDefine.getColorStr("DE6D29", config.name);
	elseif config.color == 4 then
		self.name.text = Lua_ColorDefine.getColorStr("C616B7", config.name);
	else
		self.name.text = Lua_ColorDefine.getColorStr("159EC5", config.name);
	end
	self.attr_des.text = config.attr_des;

	if config.buff_camp == 7 then
		self.icon:setAltas("common_altas_2", "ui_common_button_025_n");
	else
		self.icon:setAltas("common_altas_2", "ui_common_button_0"..(25 + config.buff_camp).."_n");
	end
	self.icon:resetSize();

	config = Lua_SkillConfigData.getConfigData(config.skill_id);
	self.skill_icon:setAltas(config.atlas, config.sprite);
	self.skill_icon:resetSize();
	self.skill_des = config.des;
end

function Lua_ExpeditionBuffItem:onPressClick()
	if self.skill_des == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_ExpeditionBuffDetailsWindow", Lua_WinParam.ACTION_OPEN, self.skill_des);
end