-- 难度选择
Lua_ExpeditionDifficultyWindow = class("Lua_ExpeditionDifficultyWindow", Lua_Window);
function Lua_ExpeditionDifficultyWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ExpeditionDifficultyWindow";
	self.skinName = "ExpeditionDifficultyWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ExpeditionDifficultyWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.prompt:setLangValue(330015);

	local simple_param = DataCenter.expeditionUtil:getConstConfig("simple_param", 3);
	local difficult_param = DataCenter.expeditionUtil:getConstConfig("difficult_param", 3);

	self.simple.text = LanUtil.formateStr(330014, tostring(simple_param[1]), tostring(simple_param[2]));
	self.difficulty.text = LanUtil.formateStr(330014, tostring(difficult_param[1]), tostring(difficult_param[2]));

	self.btnSimple:addClickFuntion(self, self.onBtnSimpleClick);
	self.btnDifficulty:addClickFuntion(self, self.onBtnDifficultyClick);
end

function Lua_ExpeditionDifficultyWindow:dispose()
	self:superCall("dispose");
end

function Lua_ExpeditionDifficultyWindow:onBtnSimpleClick(go)
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sDifficultyChoose(1);
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sNextLayer();
	self:hide();
end

function Lua_ExpeditionDifficultyWindow:onBtnDifficultyClick(go)
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sDifficultyChoose(2);
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sNextLayer();
	self:hide();
end