Lua_ExpeditionHeroItem = class("Lua_ExpeditionHeroItem", Lua_ListCell);
function Lua_ExpeditionHeroItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ExpeditionHeroItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setRectAnchor(1);
	self.itemIcon:setLocation(0, -55, 0);
	self.itemIcon:setScale(0.9, 0.9, 0.9);

	self.hpBar = UICreate.createProgressBar(self.content, "expedition_atlas_1", "ui_bjyz_progress_001_f", "expedition_atlas_1", "ui_bjyz_progress_001_b", 0, -125, 100, 14);
	self.hpBar:setBarOffset(0, 2);
	self.hpBar:setMaxValue(1);
	self.hpBar:setValue(0);
	self.hpBar.anchorValue = 1;
end

function Lua_ExpeditionHeroItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.hpBar = nil;
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ExpeditionHeroItem:setData(data)
	self.data = DataCenter.expeditionData:getLineupHeroVo(data);

	self.itemIcon:setData(self.data);
	self.itemIcon:show_level(self.data.level);

	if self.data.assist == 0 then
		self:showAssistIcon(false);
	else
		self:showAssistIcon(true);
	end
	
	if self.data.blood > 0 then
		self.itemIcon:setMask(false);
		self:showDeadIcon(false);
	else
		self.itemIcon:setMask(true);
		self:showDeadIcon(true);
	end

	self.hpBar:setMaxValue(self.data.max_blood);
	self.hpBar:setValue(self.data.blood);
end

function Lua_ExpeditionHeroItem:showAssistIcon(bShow)
	if bShow then
		if self.assistIcon == nil then
			self.assistIcon = UICreate.createUIAtlasImage(self.content, "common_altas_3", "ui_bjyz_label_04", 33, -17, 0, 0);
			self.assistIcon:setScale(0.8, 0.8, 0.8);
		end
		self.assistIcon:setEnable(true);
	else
		if self.assistIcon ~= nil then
			self.assistIcon:setEnable(false);
		end
	end
end

function Lua_ExpeditionHeroItem:showDeadIcon(bShow)
	if bShow then
		if self.deadIcon == nil then
			self.deadIcon = UICreate.createUIAtlasImage(self.content, "expedition_atlas_1", "ui_bjyz_label_05", 0, 0, 0, 0);
		end
		self.deadIcon:setEnable(true);
	else
		if self.deadIcon ~= nil then
			self.deadIcon:setEnable(false);
		end
	end
end

function Lua_ExpeditionHeroItem:onPressClick()
	if self.data == nil then
		return;
	end
	local heroVo = DataCenter.heroData:getItemByUniqueId(self.data.unique_id);
	if heroVo == nil then
		Lua_ProxyManager.getProxy("Lua_HeroProxy"):sCheckRoleHeroInfo(self.data.unique_id);
	else
		Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, heroVo);
	end
end