-- 复活卡
checkRequire("Lua_ExpeditionHeroItem");
Lua_ExpeditionHeroReviveWindow = class("Lua_ExpeditionHeroReviveWindow", Lua_Window);
function Lua_ExpeditionHeroReviveWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ExpeditionHeroReviveWindow";
	self.skinName = "ExpeditionHeroReviveWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ExpeditionHeroReviveWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.des:setLangValue(330006);
	self.prompt:setLangValue(330007);

	self.itemList = Lua_DragList.new(self.content, 600, 510, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, 16, 0);
	self.itemList:setListCell(Lua_ExpeditionHeroItem, 112, 140, 5);
	self.itemList:setCellSpacing(10, 0);

	self.btnHelp:addClickFuntion(self, self.onBtnHelpClick);
	self.btnUse:addClickFuntion(self, self.onBtnUseClick);
	
	self:addLuaEvent("EXPEDITION_HAVEHERO_LIST", self, self.updateShowInfo)
	self:updateShowInfo()
end

function Lua_ExpeditionHeroReviveWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self.costId = nil;
	self.haveNum = nil;
	self:superCall("dispose");
end

function Lua_ExpeditionHeroReviveWindow:updateItemInfo()
	self.costId = DataCenter.expeditionUtil:getConstConfig("revive_item", 1);
	self.haveNum = DataCenter.packData:getItemCountById(self.costId);
	self.haveCount.text = self.haveNum;
end

function Lua_ExpeditionHeroReviveWindow:updateShowInfo()
	local arr = DataCenter.expeditionData.havaHeroArr
	arr:sortf(self, self.heroSortFun)
	self.itemList:setArrayData(arr)
	self:updateItemInfo();
end

function Lua_ExpeditionHeroReviveWindow:heroSortFun(a, b)
	a = DataCenter.expeditionData:getLineupHeroVo(a);
	b = DataCenter.expeditionData:getLineupHeroVo(b);
	local _a = a.blood / a.max_blood
	local _b = b.blood / b.max_blood
	if _a > _b then
		return false
	elseif _a == _b then
		if a.heroForce < b.heroForce then
			return false
		end
	end
	return true
end

function Lua_ExpeditionHeroReviveWindow:onBtnHelpClick(go)
	local tipsData = { posX = -182, posY = 330, needAdapt = false, des = LanUtil.getValue(330008) };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_ExpeditionHeroReviveWindow:onBtnUseClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.showLangValue(10031);
		return;
	end
	self.clickTime = getTime();

	if not DataCenter.expeditionData.haveHeroDeath then
		OperateAlert.showLangValue(330009);
		return;
	end

	if self.haveNum > 0 then
		local tipsData = { font_size = 28, des = LanUtil.getValue(330010), btnType = 1, owner = self, sureFun = self.onSureFun };
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		DataCenter.packUtil:openPathWindow(self.costId);
	end
end

function Lua_ExpeditionHeroReviveWindow:onSureFun()
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sUseReviveItem();
	OperateAlert.showLangValue(330038);
end