-- 边境远征
checkRequire("Lua_ExpeditionSingleItem");
checkRequire("Lua_ExpeditionBoxItem");
Lua_ExpeditionWindow = class("Lua_ExpeditionWindow", Lua_Window);
function Lua_ExpeditionWindow:ctor()
	self:superCall("ctor");
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_ExpeditionWindow";
	self.skinName = "ExpeditionWindow_skin";
	self.isFullSizeWin = true;
	self.isFullPaving = true;
    self.bgWidth = 720;
    self.bgHight = 2245;
	self:addPreLoadRes("/images/expedition/ui_bjyz_bj_01.jpg", Lua_LoadFileType.IMG);
	self:addPreLoadRes("/images/expedition/ui_bjyz_bj_02.jpg", Lua_LoadFileType.IMG);
end

function Lua_ExpeditionWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.bShowDoubleIcon = true;
	self.subRectH = self.bgHight - self.height;
	self.cellHeight = 0;
	self.subMinPos = -self.subRectH / 2;
	self.subMaxPox = -self.subMinPos;
	self.spaceWidth = 210;

    self.scrollContainer = UICreate.createScrollContainer(self.content, 0, 0, self.width, self.height);
    self.scrollContainer.bCreateContent = true;
    self.scrollContainer.horizontal = false;
    self.scrollContainer.vertical = true;
    self.scrollContainer.movementTypeValue = 2;
    self.scrollContainer.elasticity = 0.3;
    self.scrollContainer.inertia = true;
    self.scrollContainer:setScrollSize(0, self.subRectH);
    self.scrollContainer:setScrollPivot(4);
    self.scrollContainer:addMousDownFuntion(self, self.onMouseDownFun);
    self.scrollContainer:addMouseUpFuntion(self, self.onMouseUpFun);
    self.scrollContainer.siblingIndex = 0;

    self.sub = self.scrollContainer.scrollContent;
    self.subRect = self.scrollContainer.scrollRect;

    self.showImg1 = UICreate.createImage(self.sub, "/images/expedition/ui_bjyz_bj_01.jpg", 0, self.bgHight / 2, self.bgWidth, 1000);
    self.showImg1.pivotValue = 1;
    self.showImg2 = UICreate.createImage(self.sub, "/images/expedition/ui_bjyz_bj_02.jpg", 0, self.bgHight / 2 - 1000, self.bgWidth, 1000);
    self.showImg2.pivotValue = 1;
    self.showImg3 = UICreate.createImage(self.sub, "/images/expedition/ui_bjyz_bj_03.jpg", 0, self.bgHight / 2 - 2000, self.bgWidth, 245);
    self.showImg3.pivotValue = 1;
    self.showImg1:addLoadCompleteFun(self, self.onShowImg1Loaded);
    self.showImg2:addLoadCompleteFun(self, self.onShowImg2Loaded);

	self.bgEff1 = UICreate.createUIEffect(self.sub, "/effects/uiEffects/ui_bjyz_bg_01", "ui_bjyz_bg_01", 0, 770);
	self.bgEff2 = UICreate.createUIEffect(self.sub, "/effects/uiEffects/ui_bjyz_bg_01", "ui_bjyz_bg_01", 0, 50);
	self.bgEff3 = UICreate.createUIEffect(self.sub, "/effects/uiEffects/ui_bjyz_bg_01", "ui_bjyz_bg_01", 0, -770);

    self.modelImg = UICreate.createImage(self.sub, nil, 10, 678, 0, 0);

	self.btnHelp:addClickFuntion(self, self.onBtnHelpClick);
	self.revivalIcon:addClickFuntion(self, self.onRevivalIconClick);
	-- self.heroIcon:addClickFuntion(self, self.onHeroIconClick);
	self.buffIcon:addClickFuntion(self, self.onBuffIconClick);
	self.shopIcon:addClickFuntion(self, self.onShopIconClick);
	self.doubleIcon:addClickFuntion(self, self.onDoubleIconClick);
	self.checkTreasure:addClickFuntion(self, self.onCheckTreasure);

	self:addLuaEvent("UPDATE_EXPEDITION_INFO", self, self.updateShowInfo);
	self:addLuaEvent("EXPEDITION_STAR_REWARD", self, self.showBox);
	self:addLuaEvent("UPDATE_MORE_DOUBLE_INFO", self, self.showDoubleIcon);--多倍活动更新
	DataCenter.expeditionData.isWait = false;
	DataCenter.expeditionData.bLayerChange = false;
	DataCenter.expeditionData.bStageChange = false;
	DataCenter.expeditionData.bLocationChange = false;
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sExpeditionInfo();
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sHaveHeroList();

	if DataCenter.expeditionData.buff_state == 1 then
		Lua_WindowUtil.openWin("Lua_ExpeditionBuffChooseWindow", Lua_WinParam.ACTION_OPEN);
	end
	self:showDoubleIcon();
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Expedition_Clearance, false, true);
end

function Lua_ExpeditionWindow:onShowImg1Loaded()
	self:checkWinBgShow();
end

function Lua_ExpeditionWindow:onShowImg2Loaded()
	self:checkWinBgShow();
end

function Lua_ExpeditionWindow:checkWinBgShow()
	if strIsNullOrEmpty(self.windowName) or self.zIndex == nil then
		return;
	end

	local bWinbgShow = false;
	if not self.isFullPaving or not self.bActive then
		bWinbgShow = false;
	else
		if self.showImg1 == nil or not self.showImg1.isActive or not self.showImg1.bLoadedState then
			bWinbgShow = false;
		elseif self.showImg2 == nil or not self.showImg2.isActive or not self.showImg2.bLoadedState then
			bWinbgShow = false;
		else
			bWinbgShow = true;
		end
	end

	if self.showWinBgComplete ~= bWinbgShow then
		self.showWinBgComplete = bWinbgShow;
		MsgUtil.callFunc("WINDOW_FullPAVING_WINBG_SHOW", self.zIndex);
	end
end

function Lua_ExpeditionWindow:updateDoubleServerInfo()
	
end

function Lua_ExpeditionWindow:onBackBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1035, true);
end

function Lua_ExpeditionWindow:dispose()
	if self.bPreLoad == true then
		self.bPreLoad = false;
		DataCenter.preLoadData:removeBySign("Lua_ExpeditionWindow", self, self.onLoaded);
	end
	Lua_CommonUtil.removeTimer(self, self.updateMap)
	Lua_CommonUtil.removeTimer(self, self.moveToIndex)
	Lua_CommonUtil.removeTimer(self, self.onDoubleIconClick);
	self:stopTimer();
	self:stopMoveTimer();
	if self.modelEffImg then
		TweenUtil.getInstance():stop(self.modelEffImg.mainContent)
	end
	if self.bgEff1 then
		self.bgEff1:dispose();
		self.bgEff1 = nil;
	end
	if self.bgEff2 then
		self.bgEff2:dispose();
		self.bgEff2 = nil;
	end
	if self.bgEff3 then
		self.bgEff3:dispose();
		self.bgEff3 = nil;
	end
	if self.showList ~= nil then
		self.showList:dispose();
		self.showList:clear();
		self.showList = nil;
	end
	if self.hideList ~= nil then
		self.hideList:dispose();
		self.hideList:clear();
		self.hideList = nil;
	end
	if self.boxArr ~= nil then
		self.boxArr:dispose();
		self.boxArr:clear();
		self.boxArr = nil;
	end
    self.sub = nil;
    self.subRect = nil;
    if self.scrollContainer ~= nil then
        self.scrollContainer:dispose();
        self.scrollContainer = nil;
    end
    self.showMask = nil;
	self:superCall("dispose");
end

function Lua_ExpeditionWindow:onScreenResize()
	self:superCall("onScreenResize");
	self.subRectH = self.bgHight - self.height;
	self.cellHeight = self.subRectH / self.cellsCount;
	self.subMinPos = -(self.bgHight - self.height) / 2;
	self.subMaxPox = -self.subMinPos;

	self.scrollContainer:SetDimensions(self.width, self.height);
	self.scrollContainer:setScrollSize(0, self.subRectH);
end

function Lua_ExpeditionWindow:onMouseDownFun()
	self:stopMoveTimer();
	self.startMouseX = CommonUtil.mousePositionX;
	self.startMouseY = CommonUtil.mousePositionY;
	self.startClickTime = getTime();
	self.pressItem = self:checkClick();
end

function Lua_ExpeditionWindow:onMouseUpFun()
	if self.pressItem ~= nil then
		local dx = CommonUtil.mousePositionX - self.startMouseX;
		local dy = CommonUtil.mousePositionY - self.startMouseY;
		if getTime() - self.startClickTime <= 0.3 and Mathf.Abs(dx) + Mathf.Abs(dy) < 4 then
			self.pressItem:onPressClick()
		end
	end
	self.pressItem = nil;
end

function Lua_ExpeditionWindow:checkClick()
	if self.showList ~= nil then
		local winPos = LuaUtil.getTouchPosInverseObj(self.sub);
		local len = self.showList:getSize();
		for i = 1, len do
			if self.showList[i].isActive and self.showList[i]:checkInBound(winPos.x, winPos.y) then
				return self.showList[i];
			end
		end
	end
    return nil;
end

function Lua_ExpeditionWindow:updateShowInfo(value)
	local data = DataCenter.expeditionData;
	-- print(data.cur_stage, data.cur_location, data.cur_state, data.buff_state)

	if data.cur_layer == 3 then
		self.startY = 1038;
		self.modelImg:setUrl("/images/expedition/ui_bjyz_icon_bg_03.png");
	else
		self.startY = 945;
		self.modelImg:setUrl("/images/expedition/ui_bjyz_icon_bg_02.png");
	end

	local str = LanUtil.formateStr(330001, convert_arab_to_chinese(data.cur_layer));
	if data.cur_difficulty == 1 then
		str = spliceStr(str, LanUtil.formateStr(10048, LanUtil.getValue(330004)));
	elseif data.cur_difficulty == 2 then
		str = spliceStr(str, LanUtil.formateStr(10048, LanUtil.getValue(330005)));
	end
	self.layerText.text = str;
	self.reward_1.text = data.expedition_amount;
	self.reward_2.text = data.coin_amount;

	local sub_times = DataCenter.expeditionUtil:getConstConfig("sub_times", 1, 0) * 60;
	self.left_sec = data.left_sec - sub_times;
	if self.left_sec > 0 then
		self.isstopTimer = false;
	else
		self.left_sec = data.left_sec;
		self.isstopTimer = true; -- 结算期
	end
	self:startTimer();
	self:onTimer();

	if value == true then
		self:updateModel(value);
	else
		self:updateMap(value);
		self:updateModel(value);
	end
	self:showBox();

	self.checkTreasure:setEnable(data.bTreasure);
end

function Lua_ExpeditionWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = false;
		self:addTimer("Lua_ExpeditionWindow", 1, self, self.onTimer);
	end
end

function Lua_ExpeditionWindow:stopTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_ExpeditionWindow:onTimer()
	self.left_sec = self.left_sec - 1;
	if self.left_sec > 0 then
		if self.isstopTimer then
			self.timeText:setLangValue(330003);
		else
			self.timeText.text = LanUtil.formateStr(330002, Lua_TimeTransform.transSeconds6(self.left_sec));
		end
	else
		self:stopTimer();
		self.timeText.text = nil
	end
end

function Lua_ExpeditionWindow:updateModel(value)
	if self.showList then
		local data = DataCenter.expeditionData;
		local id, lattice = data:getModelPosInfo();
		local modelIdx = 1
		local modelPosX
		local modelPosY
		local item
		for i = 1, self.showList:getSize() do
			item = self.showList[i]
			if item.data.id == id and item.index == lattice then
				item:init()
				modelIdx = i
				modelPosX = item.x
				if i == 2 and data.cur_layer == 3 then
					modelPosY = item.y + 64
				else
					modelPosY = item.y + 84
				end
				break
			end
		end
		if self.modelIdx and self.modelIdx > modelIdx then
			self:showModel(modelPosX, modelPosY, true)
		else
			self:showModel(modelPosX, modelPosY)
		end
		self.modelIdx = modelIdx

		if value == true then
			if self.tzEffUrl == nil then
				self.tzEffUrl = UrlManager.fixFileSuffix("/effects/uiEffects/ui_bjyz_tz");
			end
			if self.bPreLoad ~= true and not LoadManager.getInstance():hasResource(self.tzEffUrl) then
				self.bPreLoad = true;
				local vo = Lua_PreLoadResInfo.new();
				vo.resType = Lua_LoadFileType.UNITY3D;
				vo.resName = "/effects/uiEffects/ui_bjyz_tz";

				local loadList = Array();
				loadList:add(vo);

				DataCenter.preLoadData:preLoad("Lua_ExpeditionWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onLoaded, value, loadList, nil);
			elseif not self.bPreLoad then
				self:onLoaded(value);
			end
		end
	end
end

function Lua_ExpeditionWindow:onLoaded(value)
	self.bPreLoad = false;
	Lua_CommonUtil.delayCall(0.5, self, self.updateMap, value)
end

function Lua_ExpeditionWindow:updateMap(value)
	self:returntItem();

	local data = DataCenter.expeditionData;
	local arr = DataCenter.expeditionUtil:getMapArr(data.cur_layer, data.cur_difficulty);
	self.cellsCount = arr:getSize();
	self.cellHeight = self.subRectH / self.cellsCount;
	local index;
	local mapNum;
	local startX;
	local item;
	for i = 1, self.cellsCount do
		if arr[i].stage == data.cur_stage then
			index = i;
		end

		mapNum = arr[i].map;
		startX = -(mapNum - 1) * self.spaceWidth / 2 + 10;
		for j = 1, mapNum do
			item = self:createItem();
			item:setRectSize(159, 120);
			if i == 1 then
				item:setRectSize(265, 170);
				item:setLocation(startX, 845, 0);
			elseif i == 2 then
				if data.cur_layer == 3 then
					item:setRectSize(159, 120);
					item:setLocation(startX, 810, 0);
				else
					item:setRectSize(159, 100);
					item:setLocation(startX, 705, 0);
				end
			elseif i == 3 then
				item:setRectSize(159, 100);
				if data.cur_layer == 3 then
					item:setLocation(startX, 690, 0);
				else
					item:setLocation(startX, 590, 0);
				end
			else
				item:setLocation(startX, self.startY - (i - 1) * 175, 0);
			end
			item.contentName = arr[i].id.."_"..j
			item:setData(arr[i], j, value);
			startX = startX + self.spaceWidth;
		end
	end
	index = index or 1;
	if index < Mathf.Ceil(self.cellsCount / 2) then
		index = index - 3;
	else
		index = index;
	end
	if value == true then
		Lua_CommonUtil.delayCall(0.5, self, self.moveToIndex, index)
	else
		self:moveToIndex(index);
	end
end

function Lua_ExpeditionWindow:createItem()
	if self.showList == nil then
		self.showList = Array();
	end
	if self.hideList == nil then
		self.hideList = Array();
	end
	local len = self.hideList:getSize();
	local item = nil;
	if len > 0 then
		item = self.hideList:remove();
		item:setEnable(true);
	end

	if item == nil then
		item = Lua_ExpeditionSingleItem.new(self.sub);
	end
	self.showList:add(item);
	return item;
end

function Lua_ExpeditionWindow:returntItem()
	if self.showList == nil or self.hideList == nil then
		return;
	end

	local len = self.showList:getSize();
	local item;
	while len > 0 do
		item = self.showList:remove(len);
		item.contentName = item.classname;
		item:setEnable(false);
		self.hideList:add(item)
		len = len - 1;
	end
end

function Lua_ExpeditionWindow:moveToIndex(idx)
    self.targetPos = self.subMinPos;
    for i = 1, idx - 1 do
        self.targetPos = self.targetPos + self.cellHeight;
    end

    if self.targetPos > self.subMaxPox then
        self.targetPos = self.subMaxPox;
    elseif self.targetPos < self.subMinPos then
        self.targetPos = self.subMinPos;
    end

    self:stopMoveTimer();
    self:startMoveTimer();
end

function Lua_ExpeditionWindow:startMoveTimer()
    if self.bMoveTimer ~= true then
        self.bMoveTimer = true;
        Lua_CommonUtil.addTimer("Lua_ExpeditionWindow_Move", 0.01, self, self.onMoveTimer);
    end
end

function Lua_ExpeditionWindow:stopMoveTimer()
    if self.bMoveTimer == true then
        self.bMoveTimer = false;
        Lua_CommonUtil.removeTimer(self, self.onMoveTimer);
    end
end

function Lua_ExpeditionWindow:onMoveTimer()
    local pos = self.subRect.anchoredPosition.y;
    if Mathf.Abs(pos - self.targetPos) < 2 then
        self:stopMoveTimer();
        self.scrollContainer:setScrollPosition(0, self.targetPos, 0);
    else
        pos = (self.targetPos - pos) * 0.1 + pos;
        self.scrollContainer:setScrollPosition(0, pos, 0);
    end
end

function Lua_ExpeditionWindow:showBox(arr)
	if arr and self.boxArr then
		for i = 1, arr:getSize() do
			for j = 1, self.boxArr:getSize() do
				if self.boxArr[j].data.id == arr[i] then
					self.boxArr[j]:showReceiveEff(true);
					break;
				end
			end
		end
	end

	local config = DataCenter.expeditionUtil:getStarInfo();
	table.sort(config, function(a, b) return a.id < b.id end);
	local dataLen = config == nil and 0 or #config;
	local starNum = DataCenter.expeditionData.star_num;
	local maxNum = config[dataLen].star_num;
	self.reward_3.text = "（"..starNum.."/"..maxNum.."）";

	local value = 0;
	local index = 1;
	if starNum >= maxNum then
		value = maxNum;
	else
		local oneMax = maxNum / dataLen; -- 每一段的最大值
		for i = 1, dataLen do
			if config[i].star_num >= starNum then
				index = i;
				break;
			end
		end
		value = value + oneMax * (index - 1); -- 当前所在段之前所有值

		local num;
		if index <= 1 then
			num = oneMax / config[index].star_num;
			value = value + starNum * num;
		else
			num = oneMax / (config[index].star_num - config[index - 1].star_num);
			value = value + (starNum - config[index - 1].star_num) * num;
		end
	end
	self.boxBar:setMaxValue(maxNum * 100);
	self.boxBar:setValue(value * 100);

	if self.boxArr == nil then
		self.boxArr = Array();
	end
	local len = self.boxArr:getSize();
	maxNum = len > dataLen and len or dataLen;
	local item;
	for i = 1, maxNum do
		item = self.boxArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_ExpeditionBoxItem.new(self.content);
				self.boxArr:add(item);
			else
				item:setEnable(true);
			end
			item:setLocation(-315, i / dataLen * 659 - 334, 0);
			item:setData(config[i]);
		end
	end
end

function Lua_ExpeditionWindow:showModel(posX, posY, value)
	if self.modelEffImg == nil then
		self.modelEffImg = UICreate.createModelEffImg(self.sub, "/model/role/109000100_low", "109000100_low", posX, posY, 0, 0)
		self.modelEffImg:setCamField(1.2, 1, 100, true)
		self.modelEffImg:setCamRot(27.5, 0 ,0)
		self.modelEffImg:setCamPos(0, 4, -5.5)
		self.modelEffImg:setScale(0.3, 0.3, 1)
		self.modelEffImg:setModelEffDir(0)
		self.modelEffImg:setAction(0)
		self.modelEffImg.canRot = false
	else
		self.modelEffImg:setEnable(true)
		TweenUtil.getInstance():stop(self.modelEffImg.mainContent)
		if value == true then
			if posX > self.modelEffImg.posX then
				self.modelEffImg:setModelEffDir(15)
			elseif posX < self.modelEffImg.posX then
				self.modelEffImg:setModelEffDir(-15)
			else
				self.modelEffImg:setModelEffDir(0)
			end
			self.modelEffImg:setAction(7)
			TweenUtil.getInstance():addTweenTargetPos(self.modelEffImg.mainContent, 0.33, 0.5, posX, posY, 0, self, self.onModelTweened);
		else
			self.modelEffImg:setLocation(posX, posY, 0);
			self.modelEffImg:setModelEffDir(0)
			self.modelEffImg:setAction(0)
		end
	end
end

--双倍奖励展示
function Lua_ExpeditionWindow:showDoubleIcon()
	self:showshowMask(false);
	local bool = DataCenter.backstageActData:getActivitiesOpenState(10009, 1001);
	if bool then
		if self.bShowDoubleIcon then
			self.tips_obj:SetActive(true);
			self:showshowMask(true);
			Lua_CommonUtil.delayCall(3, self, self.onDoubleIconClick);
		else
			self.tips_obj:SetActive(false);
		end
		self.doubleIcon:setEnable(true);
		self.des_txt.text = LanUtil.getValue(671001);
	else
		self.tips_obj:SetActive(false)
		self.doubleIcon:setEnable(false);
	end
end

--tips遮罩
function Lua_ExpeditionWindow:showshowMask(bool)
	if self.showMask == nil and bool then
		self.showMask = UICreate.createUIAtlasImage(self.content, "common_altas_1", self.maskSprite, 0, 0, 2048, 2048);
		self.showMask.alpha = 0.01;
		self.showMask:addClickFuntion(self, self.onMaskClick);
	else
		if self.showMask ~= nil then
			self.showMask:setEnable(bool);
		end
	end
end

function Lua_ExpeditionWindow:onModelTweened()
	self.modelEffImg:setModelEffDir(0)
	self.modelEffImg:setAction(0)
end

function Lua_ExpeditionWindow:onBtnHelpClick(go)
	local tipsData = { posX = 210, posY = -165, des = LanUtil.getValue(330000) };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_ExpeditionWindow:onRevivalIconClick(go)
	Lua_WindowUtil.openWin("Lua_ExpeditionHeroReviveWindow", Lua_WinParam.ACTION_OPEN);
end

-- function Lua_ExpeditionWindow:onHeroIconClick(go)
-- 	Lua_WindowUtil.openWin("Lua_ExpeditionHeroWindow", Lua_WinParam.ACTION_OPEN);
-- end

function Lua_ExpeditionWindow:onBuffIconClick(go)
	Lua_WindowUtil.openWin("Lua_ExpeditionBuffWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ExpeditionWindow:onShopIconClick(go)
	DataCenter.funcPathUtil:gotoFunction(1043)
end

function Lua_ExpeditionWindow:onDoubleIconClick()
	if self.bShowDoubleIcon then
		self.bShowDoubleIcon = false;
		self.tips_obj:SetActive(false);
		self:showshowMask(false);
	else
		self.bShowDoubleIcon = true;
		self.tips_obj:SetActive(true);
		self:showshowMask(true);
	end
	Lua_CommonUtil.removeTimer(self, self.onDoubleIconClick);
	if DataCenter.roleData:getOperationRecord("expedition_double") == 0 then
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("expedition_double", 1);
	end
end

function Lua_ExpeditionWindow:onMaskClick(go)
	self:onDoubleIconClick()
end

function Lua_ExpeditionWindow:onCheckTreasure(go)
	Lua_WindowUtil.openWin("Lua_ExpeditionTreasureWindow", Lua_WinParam.ACTION_OPEN);
end