checkRequire("Lua_ExpeditionHeroGridItem");
checkRequire("Lua_ArtifactSkillItem");
Lua_ExpeditionChallengeWindow = class("Lua_ExpeditionChallengeWindow", Lua_Window);
function Lua_ExpeditionChallengeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ExpeditionChallengeWindow";
	self.skinName = "ExpeditionChallengeWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ExpeditionChallengeWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.artifactArr = Array();
	self.winIdxDic = {}; -- 胜利的队伍记录

	self.leftAvatar = Lua_AvatarItem.new(self.content);
	self.leftAvatar:setLocation(-290, 326, 0);
	self.leftAvatar:setScale(0.54, 0.54, 1);

	self.rightAvatar = Lua_AvatarItem.new(self.content);
	self.rightAvatar:setLocation(290, 326, 0);
	self.rightAvatar:setScale(0.54, 0.54, 1);

	self.leftForce = Lua_NumberImage.new(self.content);
	self.leftForce:setLocation(-224, 313, 0);
	self.leftForce.pivot = 1;
	self.leftForce.scaleVal = 0.8;
	self.leftForce.numOffsetX = -3;
	self.leftForce.numAtlas = "number";
	self.leftForce.preStr = "xui_zl1_number_0";

	self.rightForce = Lua_NumberImage.new(self.content);
	self.rightForce:setLocation(250, 313, 0);
	self.rightForce.pivot = -1;
	self.rightForce.scaleVal = 0.8;
	self.rightForce.numOffsetX = -3;
	self.rightForce.numAtlas = "number";
	self.rightForce.preStr = "xui_zl1_number_0";

	self.leftPanel = Lua_HeroGridViewPanel.new(self.content);
	self.leftPanel:setLocation(-179, 157, 0);
	self.leftPanel:setGridCell(70, 85, Lua_ExpeditionHeroGridItem);
	self.leftPanel:setCanClick(true);

	self.rightPanel = Lua_HeroGridViewPanel.new(self.content);
	self.rightPanel:setLocation(179, 157, 0);
	self.rightPanel:setLayout(1, 2);
	self.rightPanel:setGridCell(70, 85, Lua_ExpeditionHeroGridItem);
	self.rightPanel:setCanClick(true);

	self.btnLeft:setEnable(false);
	self.btnLeft:addClickFuntion(self, self.onLeftClick);
	self.btnRight:setEnable(false);
	self.btnRight:addClickFuntion(self, self.onRightClick);
	self.cbSkip:setEnable(false);
	self.cbSkip:addBoxChange(self, self.onSkipChange);
	self.btnLayOut:addClickFuntion(self, self.onBtnLayOutClick);
	self.btnChallenge:addClickFuntion(self, self.onBtnChallengeClick);

	self:addLuaEvent("EXPEDITION_CHALLENGE_INFO", self, self.updateShowInfo);
	self:addLuaEvent("UPDATE_HERO_LINEUP_INFO", self, self.onLineupUpdate);
end

function Lua_ExpeditionChallengeWindow:dispose()
	DataCenter.preLoadData:removeBySign("Lua_ExpeditionLineupWindow", self, self.onSceneShow);
	if self.leftAvatar ~= nil then
		self.leftAvatar:dispose();
		self.leftAvatar = nil;
	end
	if self.rightAvatar ~= nil then
		self.rightAvatar:dispose();
		self.rightAvatar = nil;
	end
	if self.leftForce then
		self.leftForce:dispose();
		self.leftForce = nil;
	end
	if self.rightForce then
		self.rightForce:dispose();
		self.rightForce = nil;
	end
	if self.leftPanel ~= nil then
		self.leftPanel:dispose();
		self.leftPanel = nil;
	end
	if self.rightPanel ~= nil then
		self.rightPanel:dispose();
		self.rightPanel = nil;
	end
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.artifactArr then
		self.artifactArr:dispose();
		self.artifactArr = nil;
	end
	if self.btnList then
		self.btnList:dispose();
		self.btnList = nil;
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	self.winIdxDic = nil;
	self.data = nil;
	self.eventData = nil;
	self:superCall("dispose");
end

function Lua_ExpeditionChallengeWindow:showWin(param)
	self:superCall("showWin", param);

	local eventId = DataCenter.expeditionData:getLatticeEvent(param.stageId, param.index);
	if eventId == 8 then
		self.promptText:setLangValue(330042);
	else
		self.promptText:setLangValue(330017);
	end
	self.eventData = DataCenter.expeditionUtil:getLatticeInfo(eventId);
	self.titleName.text = self.eventData.name;

	local one_key_skip = DataCenter.expeditionUtil:getConstConfig("one_key_skip", 1);
	self.cbSkip:setEnable(param.canOperate == true and DataCenter.funcOpenData:isOpened(one_key_skip));
	self.cbSkip.selected = DataCenter.expeditionData.one_key_skip == 1;
	self.btnLayOut:setEnable(param.canOperate == true);
	self.btnChallenge:setEnable(param.canOperate == true);
	self:getServerInfo();
end

function Lua_ExpeditionChallengeWindow:updateShowInfo(msg)
	self.data = msg;
	if msg == nil then
		return;
	end

	-- self.leftAvatar:setRoleId(msg.self_player.id);
	self.leftAvatar:setRoleDressUp(msg.self_player.dress_info);
	self.leftName.text = msg.self_player.name;

	-- self.rightAvatar:setRoleId(msg.def_player.id);
	self.rightAvatar:setRoleDressUp(msg.def_player.dress_info);
	self.rightName.text = msg.def_player.name;

	local blueCount = 0;
	local purpleCount = 0;
	local orangeCount = 0;
	if msg.buff_list ~= nil then
		local config;
		for i = 1, #msg.buff_list do
			config = DataCenter.expeditionUtil:getBuffInfo(msg.buff_list[i]);
			if config ~= nil then
				if config.color == 3 then
					blueCount = blueCount + 1;
				elseif config.color == 4 then
					purpleCount = purpleCount + 1;
				elseif config.color == 5 then
					orangeCount = orangeCount + 1;
				end
			end
		end
	end
	self.blueCount.text = blueCount;
	self.purpleCount.text = purpleCount;
	self.orangeCount.text = orangeCount;
	self.forceAdd.text = LanUtil.formateStr(330018, tostring(msg.force_add));

	if self.itemList == nil then
		local num = msg.reward_items == nil and 0 or #msg.reward_items;
		local itemW = Mathf.Ceil(124 * 0.7);
		local width = num * itemW + (num - 1) * 10;
		self.itemList = Lua_DragList.new(self.content, width, 92, Lua_AxisDefine.Horizontal);
		self.itemList:setLocation(25, -196);
		self.itemList:setListCell(Lua_ExpeditionChallengeItem, itemW, 92, 1);
		self.itemList:setCellSpacing(10, 0);
	end
	self.itemList:setArrayData(msg.reward_items);

	self.lineupLen = #msg.def_lineup_list
	if self.lineupLen > 1 then
		local selectIdx
		if self.btnList == nil then
			self.btnInfo = Array();
			local str;
			local info;
			local blood;
			for i = 1, self.lineupLen do
				str = "xui_bz_button_"..(13 + i).."_n";
				self.btnInfo:add({ textAtlas = "hero_embattle", textNormalSprite = str, textSelectedSprite = str });

				if selectIdx == nil then
					info = self.data.def_lineup_list[i]
					blood = 0;
					for j = 1, #info.hero_list do
						blood = blood + info.hero_list[j].blood
					end
					if selectIdx == nil and blood > 0 then
						selectIdx = i
					end
					if blood <= 0 then
						self.winIdxDic[i] = 1
					end
				end
			end
			selectIdx = selectIdx or 1;

			self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
			self.btnList:setRectPivot(5);
			self.btnList:setLocation(326, -19.5, 0);
			self.btnList.pivot = -1;
			self.btnList:setButtonStyle("hero_embattle", "xui_bz_button_17_n", "xui_bz_button_17_n", 55, 55, 0.01, 1);
			self.btnList:setButtonItem(55, 55);
			self.btnList:setClickCallBack(self, self.showLineupInfo);
			self.btnList:setData(self.btnInfo);
			self.btnList:setSelected(selectIdx);
		else
			selectIdx = self.btnList.selectedIdx
			self.btnList.selectedIdx = nil
			self.btnList:setSelected(selectIdx);
		end
	else
		self:showLineupInfo(1);
	end
end

function Lua_ExpeditionChallengeWindow:showLineupInfo(index)
	self.lineupIdx = index;
	self.btnLeft:setEnable(self.lineupLen > 1 and index > 1);
	self.btnRight:setEnable(self.lineupLen > 1 and index < self.lineupLen);

	local idx = 0
	local info = self.data.self_lineup_list[index]
	if info then
		self.leftPanel:setStandType(info.stand_type);
		self.leftPanel:setDataByProto(info.hero_list);
		self.leftForce.num = info.force;

		local list = info.artifact_skill_id_list
		local item
		for i = 1, #list do
			idx = idx + 1
			item = self.artifactArr[idx]
			if item == nil then
				item = Lua_ArtifactSkillItem.new(self.content)
				self.artifactArr:add(item)
			end
			item:setLocation(-275 + (i - 1) * 90, -90, 0)
			if list[i].value == 1 then
				item:setSkillId(list[i].key)
			else
				item:setSkillId(nil)
			end
		end
	else
		self.leftPanel:setDataByProto(nil);
	end

	info = self.data.def_lineup_list[index]
	if info then
		self.rightPanel:setStandType(info.stand_type);
		self.rightPanel:setDataByProto(info.hero_list);
		self.rightForce.num = info.force;
		self.forceIcon_2:setLocation(250 - self.rightForce.totalWidth - 15, 313, 0);

		list = info.artifact_skill_id_list
		for i = 1, #list do
			idx = idx + 1
			item = self.artifactArr[idx]
			if item == nil then
				item = Lua_ArtifactSkillItem.new(self.content)
				self.artifactArr:add(item)
			end
			item:setLocation(275 - (i - 1) * 90, -90, 0)
			if list[i].value == 1 then
				item:setSkillId(list[i].key)
			else
				item:setSkillId(nil)
			end
		end
	else
		self.rightPanel:setDataByProto(nil);
	end
end

function Lua_ExpeditionChallengeWindow:onLineupUpdate(lineup_type)
	if lineup_type == Lua_HeroUtil.LINEUP_EXPEDITION or lineup_type == Lua_HeroUtil.LINEUP_EXPEDITION_TEAM then
		self:getServerInfo();
	end
end

function Lua_ExpeditionChallengeWindow:getServerInfo()
	if self.showData == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sChallengeInfo(self.showData.stageId, self.showData.index);
end

function Lua_ExpeditionChallengeWindow:onLeftClick(go)
	if self.clickTime and getTime() - self.clickTime < 0.3 then
		return;
	end
	self.clickTime = getTime();

	self.lineupIdx = self.lineupIdx - 1;
	self.btnList:setSelected(self.lineupIdx);
end

function Lua_ExpeditionChallengeWindow:onRightClick(go)
	if self.clickTime and getTime() - self.clickTime < 0.3 then
		return;
	end
	self.clickTime = getTime();

	self.lineupIdx = self.lineupIdx + 1;
	self.btnList:setSelected(self.lineupIdx);
end

function Lua_ExpeditionChallengeWindow:onSkipChange(bChange)
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sSkipFight(bChange == true and 1 or 0);
end

function Lua_ExpeditionChallengeWindow:onBtnLayOutClick(go)
	if self.data == nil then
		return;
	end
	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_EXPEDITION);
	DataCenter.preLoadData:preShowScene("Lua_ExpeditionLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_ExpeditionChallengeWindow:onSceneShow(param)
	if self.lineupLen > 1 then
		param = { lineupType = Lua_HeroUtil.LINEUP_EXPEDITION_TEAM, name = self.eventData.name, def_lineup_list = self.data.def_lineup_list };
	else
		param = { lineupType = Lua_HeroUtil.LINEUP_EXPEDITION, name = self.eventData.name, def_lineup_list = self.data.def_lineup_list };
	end
	Lua_WindowUtil.openWin("Lua_ExpeditionLineupWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_ExpeditionChallengeWindow:onBtnChallengeClick(go)
	if self.showData == nil or self.data == nil then
		return;
	end

	local vo;
	local num;
	local stand_type;
	local position_list;
	if self.lineupLen > 1 then
		vo = DataCenter.heroLineupData:getLineupVo(Lua_HeroUtil.LINEUP_EXPEDITION_TEAM)
		for i = 1, self.lineupLen do
			if self.winIdxDic[i] ~= 1 then
				num = vo:getHeroNumByLineupIdx(i)
				if num == 0 then
					OperateAlert.show(LanUtil.formateStr(126326, convert_arab_to_chinese(i)));
					return
				end
			end
		end
		for i = 1, self.lineupLen do
			if self.winIdxDic[i] ~= 1 then
				num = vo:getHeroNumByLineupIdx(i)
				stand_type = vo:getStandType(i)
				position_list = DataCenter.heroLineupUtil:getStandListByType(stand_type);
				if num < #position_list and DataCenter.expeditionData:checkPackHaveHero(vo.id) then
					local tipsData = { des = 126312, btnType = 1, owner = self, sureFun = self.onSureFun }
					Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData)
					return
				end
			end
		end
	else
		vo = DataCenter.heroLineupData:getLineupVo(Lua_HeroUtil.LINEUP_EXPEDITION)
		num = vo:getHeroNumByLineupIdx(1)
		if num == 0 then
			OperateAlert.showLangValue(126307)
			return
		end
			stand_type = vo:getStandType(1)
			position_list = DataCenter.heroLineupUtil:getStandListByType(stand_type);
			if num < #position_list and DataCenter.expeditionData:checkPackHaveHero(vo.id) then
				local tipsData = { des = 126312, btnType = 1, owner = self, sureFun = self.onSureFun }
				Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData)
			return
		end
	end

	self:onSureFun();
end

function Lua_ExpeditionChallengeWindow:onSureFun()
	DataCenter.expeditionData.isWait = true
	if self.lineupLen > 1 then
		Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(Lua_FightDefine.TEMPLATE_ID_EXPEDITION_TEAM, self.showData.stageId * 100 + self.showData.index);
	else
		Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(Lua_FightDefine.TEMPLATE_ID_EXPEDITION, self.showData.stageId * 100 + self.showData.index);
	end
	self:hide();
end




















Lua_ExpeditionChallengeItem = class("Lua_ExpeditionChallengeItem", Lua_ItemIconCell);
function Lua_ExpeditionChallengeItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7, 0.7);
end