Lua_ExpeditionHeroGridItem = class("Lua_ExpeditionHeroGridItem", Lua_HeroGridViewItem);
function Lua_ExpeditionHeroGridItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ExpeditionHeroGridItem:buildShowItem()
	self:superCall("buildShowItem");

	self.bg:setAltas("expedition_atlas_2", "xui_hx_window_41");
	self.bg:resetSize();
	self.bg:setScale(0.9, 0.9, 1)
	-- self.noneIcon = UICreate.createUIAtlasImage(self.content, "expedition_atlas_2", "ui_bjyz_window_009", 0, 0, 0, 0);
end

function Lua_ExpeditionHeroGridItem:dispose()
	self:superCall("dispose");
end

function Lua_ExpeditionHeroGridItem:setStandIdx(standIdx)
	-- self.noneIcon:setEnable(standIdx == nil);
end

function Lua_ExpeditionHeroGridItem:setData(dataType, data)
	self.dataType = dataType;
	self.data = data;
	if data == nil then
		if self.itemIcon ~= nil then
			self.itemIcon:setEnable(false);
			self.itemIcon:setClick(nil, nil);
		end
		self:showAssistIcon(false);
		self:showDeadIcon(false);
		self:setHp(false);
	else
		if self.itemIcon == nil then
			self.itemIcon = Lua_ItemIcon.new(self.content);
			self.itemIcon:setScale(0.54, 0.54, 1);
		end
		self.itemIcon:setEnable(true);
		if self.bCanClick then
			self.itemIcon:setClick(self, self.onIconClick);
		else
			self.itemIcon:setClick(nil, nil);
		end
		self.itemIcon:setData(data);
		
		if data.assist == 0 then
			self:showAssistIcon(false);
		else
			self:showAssistIcon(true);
		end

		if data.blood > 0 then
			self.itemIcon:setMask(false);
			self:showDeadIcon(false);
		else
			self.itemIcon:setMask(true);
			self:showDeadIcon(true);
		end

		self:setHp(true, data.max_blood, data.blood);
	end
end

function Lua_ExpeditionHeroGridItem:setHp(bShow, maxValue, value)
	if bShow then
		if self.hpBar == nil then
			self.hpBar = UICreate.createProgressBar(self.content, "expedition_atlas_1", "ui_bjyz_progress_002_f", "expedition_atlas_1", "ui_bjyz_progress_002_b", 0, -43, 60, 8);
			self.hpBar:setBarOffset(2, 2);
		end
		self.hpBar:setEnable(true);
		self.hpBar:setMaxValue(maxValue);
		self.hpBar:setValue(value);
	else
		if self.hpBar ~= nil then
			self.hpBar:setEnable(false);
		end
	end
end

function Lua_ExpeditionHeroGridItem:showAssistIcon(bShow)
	if bShow then
		if self.assistIcon == nil then
			self.assistIcon = UICreate.createUIAtlasImage(self.content, "common_altas_3", "ui_bjyz_label_04", 21.5, -20, 0, 0);
			self.assistIcon:setScale(0.7, 0.7, 1);
		end
		self.assistIcon:setEnable(true);
	else
		if self.assistIcon ~= nil then
			self.assistIcon:setEnable(false);
		end
	end
end

function Lua_ExpeditionHeroGridItem:showDeadIcon(bShow)
	if bShow then
		if self.deadIcon == nil then
			self.deadIcon = UICreate.createUIAtlasImage(self.content, "expedition_atlas_1", "ui_bjyz_label_05", 0, 0, 0, 0);
			self.deadIcon:setScale(0.7, 0.7, 1);
		end
		self.deadIcon:setEnable(true);
	else
		if self.deadIcon ~= nil then
			self.deadIcon:setEnable(false);
		end
	end
end