-- 英雄雇佣
Lua_ExpeditionHeroHireWindow = class("Lua_ExpeditionHeroHireWindow", Lua_Window);
function Lua_ExpeditionHeroHireWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ExpeditionHeroHireWindow";
	self.skinName = "ExpeditionHeroHireWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ExpeditionHeroHireWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.des:setLangValue(330016);

	self.itemList = Lua_DragList.new(self.content, 625, 590, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_ExpeditionHeroHireItem, 625, 145, 1);

	self.btnHire:addClickFuntion(self, self.onBtnHireClick);

	self:addLuaEvent("EXPEDITION_MERCENARY_LIST", self, self.updateShowInfo);
	self:addLuaEvent("EXPEDITON_MERCENARY_SELECT", self, self.onMercenarySelected);
end

function Lua_ExpeditionHeroHireWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.heroArr ~= nil then
		self.heroArr:clear();
		self.heroArr = nil;
	end
	DataCenter.expeditionData.recordParam = nil;
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ExpeditionHeroHireWindow:showWin(param)
	self:superCall("showWin", param);

	self.btnHire:setEnable(param.canOperate == true);
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sMercenaryList(param.stageId, param.index);
end

function Lua_ExpeditionHeroHireWindow:updateShowInfo(msg)
	if msg == nil then
		return;
	end

	if self.heroArr == nil then
		self.heroArr = Array();
	end
	local arr = Array();
	local obj;
	local vo;
	for i = 1, #msg.hero_list do
		obj = msg.hero_list[i];
		vo = self.heroArr:remove();
		if vo == nil then
			vo = Lua_HeroVo.new(obj.hero_id);
		else
			vo:setData(obj.hero_id);
		end
		vo:fromServer(obj);
		arr:add(vo);
	end
	self.heroArr:clear();
	self.heroArr = arr;
	self.itemList:setArrayData(arr);
end

function Lua_ExpeditionHeroHireWindow:onMercenarySelected(data)
	if self.data == data then
		self.data = nil;
		DataCenter.expeditionData.recordParam = nil;
	else
		self.data = data;
		DataCenter.expeditionData.recordParam = data.unique_id;
	end

	local showList = self.itemList.showList;
	for i = 1, showList:getSize() do
		showList[i]:checkSelected();
	end
end

function Lua_ExpeditionHeroHireWindow:onBtnHireClick(go)
	if self.showData == nil or self.data == nil then
		return;
	end
	OperateAlert.show(LanUtil.formateStr(330035, self.data.name));
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sMercenaryChoose(self.data.unique_id, self.showData.stageId, self.showData.index);
	self:hide();
end





















Lua_ExpeditionHeroHireItem = class("Lua_ExpeditionHeroHireItem", Lua_ListCell);
function Lua_ExpeditionHeroHireItem:ctor(p)
	self:superCall("ctor", p, "ExpeditionHeroHireItem_skin");
end

function Lua_ExpeditionHeroHireItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(-140, 0, 0);

	self.cbSelect:addBoxChange(self, self.onSelectChange);
	self.btnCheck:addClickFuntion(self, self.onBtnCheckClick);
end

function Lua_ExpeditionHeroHireItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ExpeditionHeroHireItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.itemIcon:setData(data);
	self.itemIcon:show_level(data.level);
	self.name.text = data.name;
	self.force.text = LanUtil.formateStr(10039, tostring(data.heroForce));

	self:checkSelected();
end

function Lua_ExpeditionHeroHireItem:onSelectChange(bChange)
	if self.data == nil then
		return;
	end
	Lua_MsgUtil.callFunc("EXPEDITON_MERCENARY_SELECT", self.data);
end

function Lua_ExpeditionHeroHireItem:checkSelected()
	if self.data == nil then
		return;
	end

	if self.data.unique_id == DataCenter.expeditionData.recordParam then
		self.cbSelect.selected = true;
	else
		self.cbSelect.selected = false;
	end
end

function Lua_ExpeditionHeroHireItem:onBtnCheckClick(go)
	if self.data == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.data);
end