-- 复活十字架
checkRequire("Lua_ExpeditionHeroItem");
Lua_ExpeditionReviveWindow = class("Lua_ExpeditionReviveWindow", Lua_Window);
function Lua_ExpeditionReviveWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ExpeditionReviveWindow";
	self.skinName = "ExpeditionReviveWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ExpeditionReviveWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.des:setLangValue(330019);

	self.itemList = Lua_DragList.new(self.content, 600, 295, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, -161, 0);
	self.itemList:setListCell(Lua_ExpeditionHeroItem, 112, 125, 5);
	self.itemList:setCellSpacing(10, 10);

	self.btnUse:addClickFuntion(self, self.onBtnUseClick);

	self:updateShowInfo()
end

function Lua_ExpeditionReviveWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_ExpeditionReviveWindow:showWin(param)
	self:superCall("showWin", param);
	
	self.btnUse:setEnable(param.canOperate == true);
end

function Lua_ExpeditionReviveWindow:updateShowInfo()
	local arr = DataCenter.expeditionData.havaHeroArr
	arr:sortf(self, self.heroSortFun)
	self.itemList:setArrayData(arr)
end

function Lua_ExpeditionReviveWindow:heroSortFun(a, b)
	a = DataCenter.expeditionData:getLineupHeroVo(a);
	b = DataCenter.expeditionData:getLineupHeroVo(b);
	local _a = a.blood / a.max_blood
	local _b = b.blood / b.max_blood
	if _a > _b then
		return false
	elseif _a == _b then
		if a.heroForce < b.heroForce then
			return false
		end
	end
	return true
end

function Lua_ExpeditionReviveWindow:onBtnUseClick(go)
	local tipsData;
	if DataCenter.expeditionData.haveHeroDeath then
		tipsData = { des = LanUtil.getValue(330020), btnType = 1, owner = self, sureFun = self.onSureFun };
	else
		tipsData = { des = LanUtil.getValue(330021), btnType = 1, owner = self, sureFun = self.onSureFun };
	end
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_ExpeditionReviveWindow:onSureFun()
	if self.showData == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sRevive();
end