-- 补给
checkRequire("Lua_ExpeditionHeroItem");
Lua_ExpeditionSupplyWindow = class("Lua_ExpeditionSupplyWindow", Lua_Window);
function Lua_ExpeditionSupplyWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ExpeditionSupplyWindow";
	self.skinName = "ExpeditionSupplyWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ExpeditionSupplyWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.des:setLangValue(330022);

	self.itemList = Lua_DragList.new(self.content, 600, 295, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, -161, 0);
	self.itemList:setListCell(Lua_ExpeditionHeroItem, 112, 125, 5);
	self.itemList:setCellSpacing(10, 10);

	self.btnSupply:addClickFuntion(self, self.onBtnSupplyClick);

	self:updateShowInfo()
end

function Lua_ExpeditionSupplyWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_ExpeditionSupplyWindow:showWin(param)
	self:superCall("showWin", param);
	
	self.btnSupply:setEnable(param.canOperate == true);
end

function Lua_ExpeditionSupplyWindow:updateShowInfo()
	local arr = DataCenter.expeditionData.havaHeroArr
	arr:sortf(self, self.heroSortFun)
	self.itemList:setArrayData(arr)
end

function Lua_ExpeditionSupplyWindow:heroSortFun(a, b)
	a = DataCenter.expeditionData:getLineupHeroVo(a);
	b = DataCenter.expeditionData:getLineupHeroVo(b);
	local _a = a.blood / a.max_blood
	local _b = b.blood / b.max_blood
	if _a > _b then
		return false
	elseif _a == _b then
		if a.heroForce < b.heroForce then
			return false
		end
	end
	return true
end

function Lua_ExpeditionSupplyWindow:onBtnSupplyClick(go)
	local tipsData;
	if DataCenter.expeditionData.havaHeroFullBlood then
		tipsData = { des = LanUtil.getValue(330023), btnType = 1, owner = self, sureFun = self.onSureFun };
	else
		tipsData = { des = LanUtil.getValue(330024), btnType = 1, owner = self, sureFun = self.onSureFun };
	end
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_ExpeditionSupplyWindow:onSureFun()
	if self.showData == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sSupply();
end